# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
try:
	from urllib import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs
except ImportError:
	from urllib.parse import urlparse, parse_qs
from xml.dom.minidom import parseString
import re
import cntv

def httpget(url):
	try:
		file = urlopen(url)
		content = file.read()
		file.close()
		return content
	except:
		print url
		print 'captured'
		return False

def item(title, url, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode({'url': url}), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

handle = int(sys.argv[1])
if sys.argv[2] == '':
	url = 'http://ims.tian-le.com/cntv.php'
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误000')
		sys.exit(0)
	try:
		dom = parseString(content)
	except:
		xbmcgui.Dialog().ok('错误', '错误001')
		sys.exit(0)
	for element in dom.getElementsByTagName('item'):
		title = element.getElementsByTagName('title')[0].firstChild.nodeValue
		url = element.getElementsByTagName('url')[0].firstChild.nodeValue
		o = urlparse(url)
		p = o.path.split('/')
		q = parse_qs(o.query)
		l = len(p)
		if o.netloc == 'tv.cctv.com' and p[-1][:4] == 'VIDE' and p[-1][-6:] == '.shtml':
			item(title, url, False)
		else:
			item(title, url)
	xbmcplugin.endOfDirectory(handle)
else:
	url = parse_qs(urlparse(sys.argv[2]).query)['url'][0]
	o = urlparse(url)
	p = o.path.split('/')
	q = parse_qs(o.query)
	l = len(p)
	if o.netloc == 'tv.cctv.com':
		if l == 5 and p[-2] == 'videoset' and (p[-1] == '' or p[-1] == 'index.shtml'):
			ret = cntv.videoset(url)
			if ret['success'] == False:
				xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
			else:
				for elem in ret['item']:
					item(elem['title'], elem['url'], elem['folder'])
				xbmcplugin.endOfDirectory(handle)
		if p[-1][:4] == 'VIDE' and p[-1][-6:] == '.shtml':
			ret = cntv.play(url)
			if ret['success'] == False:
				xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
			else:
				play(ret['title'], 'stack://' + ' , '.join(ret['url']))
	if o.netloc == 'api.cntv.cn':
		ret = cntv.videolist(url)
		if ret['success'] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
		else:
			for elem in ret['item']:
				item(elem['title'], elem['url'], elem['folder'])
			xbmcplugin.endOfDirectory(handle)
	if o.netloc == 'vdn.live.cntv.cn':
		ret = cntv.live(url)
		if ret['success'] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
		else:
			listitem = xbmcgui.ListItem('')
			xbmc.Player().play(ret['url'], listitem)
			#play('', ret['url'])
